import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import TrashIcon from "@mui/icons-material/Delete";
import LockIcon from "@mui/icons-material/Lock";
import UnlockIcon from "@mui/icons-material/LockOpen";
import RegionIcon from "@mui/icons-material/PictureInPicture";
import ReorderIcon from "@mui/icons-material/SwapVert";
import VisibleIcon from "@mui/icons-material/Visibility";
import VisibleOffIcon from "@mui/icons-material/VisibilityOff";
import { Tooltip } from "@mui/material";
import { grey } from "@mui/material/colors";
import Grid from "@mui/material/Grid";
import { createTheme, styled, ThemeProvider } from "@mui/material/styles";
import { makeStyles } from "@mui/styles";
import classnames from "classnames";
import isEqual from "lodash/isEqual";
import React, { memo, useState } from "react";
import { asMutable } from "seamless-immutable";
import SidebarBoxContainer from "../SidebarBoxContainer";
import styles from "./styles";
var theme = createTheme();
var useStyles = makeStyles(function (theme) {
  return styles;
});
var HeaderSep = styled("div")(function (_ref) {
  var theme = _ref.theme;
  return {
    borderTop: "1px solid ".concat(grey[200]),
    marginTop: 2,
    marginBottom: 2
  };
});

var Chip = function Chip(_ref2) {
  var color = _ref2.color,
      text = _ref2.text;
  var classes = useStyles();
  return /*#__PURE__*/React.createElement("span", {
    className: classes.chip
  }, /*#__PURE__*/React.createElement("div", {
    className: "color",
    style: {
      backgroundColor: color
    }
  }), /*#__PURE__*/React.createElement("div", {
    className: "text"
  }, text));
};

var RowLayout = function RowLayout(_ref3) {
  var header = _ref3.header,
      highlighted = _ref3.highlighted,
      order = _ref3.order,
      classification = _ref3.classification,
      area = _ref3.area,
      tags = _ref3.tags,
      trash = _ref3.trash,
      lock = _ref3.lock,
      visible = _ref3.visible,
      onClick = _ref3.onClick;
  var classes = useStyles();

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      mouseOver = _useState2[0],
      changeMouseOver = _useState2[1];

  return /*#__PURE__*/React.createElement("div", {
    onClick: onClick,
    onMouseEnter: function onMouseEnter() {
      return changeMouseOver(true);
    },
    onMouseLeave: function onMouseLeave() {
      return changeMouseOver(false);
    },
    className: classnames(classes.row, {
      header: header,
      highlighted: highlighted
    })
  }, /*#__PURE__*/React.createElement(Grid, {
    container: true,
    alignItems: "center"
  }, /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 2
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      textAlign: "right",
      paddingRight: 10
    }
  }, order)), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 5
  }, classification), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 2
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      textAlign: "right",
      paddingRight: 6
    }
  }, area)), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 1
  }, trash), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 1
  }, lock), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 1
  }, visible)));
};

var RowHeader = function RowHeader(_ref4) {
  var _asMutable, _asMutable2, _asMutable3;

  var regions = _ref4.regions,
      onChangeRegion = _ref4.onChangeRegion,
      onDeleteRegion = _ref4.onDeleteRegion,
      delete_annotation = _ref4.delete_annotation,
      setdelete_annotation = _ref4.setdelete_annotation;
  var main_region = (_asMutable = asMutable(regions || [])) === null || _asMutable === void 0 ? void 0 : _asMutable.length;
  var visible = (_asMutable2 = asMutable(regions || [])) === null || _asMutable2 === void 0 ? void 0 : _asMutable2.filter(function (item) {
    return item.visible || item.visible === undefined;
  });
  var locked = (_asMutable3 = asMutable(regions || [])) === null || _asMutable3 === void 0 ? void 0 : _asMutable3.every(function (item) {
    return item.locked === false || item.locked === undefined;
  });

  var handleChangeRegion = function handleChangeRegion() {
    var action = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    return regions === null || regions === void 0 ? void 0 : regions.map(function (r) {
      return onChangeRegion(_objectSpread({}, r, action));
    });
  };

  return /*#__PURE__*/React.createElement(RowLayout, {
    header: true,
    highlighted: false,
    order: /*#__PURE__*/React.createElement(ReorderIcon, {
      className: "icon"
    }),
    classification: /*#__PURE__*/React.createElement("div", {
      style: {
        paddingLeft: 10
      }
    }, "Class") // area={<PieChartIcon className="icon" />}
    ,
    trash: /*#__PURE__*/React.createElement(Tooltip, {
      title: "Delete",
      placement: "right"
    }, /*#__PURE__*/React.createElement(TrashIcon, {
      className: "icon",
      onClick: function onClick() {
        var map_region = asMutable(regions || []);

        var delet_arr = _toConsumableArray(delete_annotation);

        delet_arr.push.apply(delet_arr, [map_region]);
        var filterArr = delet_arr && delet_arr.flat().filter(function (arr, index, self) {
          return index === self.findIndex(function (t) {
            return t.id === arr.id && arr.id;
          });
        }).map(function (item) {
          return item;
        });
        setdelete_annotation(filterArr);
        map_region.map(function (item) {
          return onDeleteRegion(item);
        });
      }
    })),
    lock: /*#__PURE__*/React.createElement(Tooltip, {
      title: "Lock/Unlock",
      placement: "right"
    }, locked ? /*#__PURE__*/React.createElement(UnlockIcon, {
      className: "icon",
      onClick: function onClick() {
        // eslint-disable-next-line no-unused-expressions
        handleChangeRegion({
          locked: true
        });
      }
    }) : /*#__PURE__*/React.createElement(LockIcon, {
      className: "icon",
      onClick: function onClick() {
        // eslint-disable-next-line no-unused-expressions
        handleChangeRegion({
          locked: false
        });
      }
    })),
    visible: /*#__PURE__*/React.createElement(Tooltip, {
      title: "Show/Hide",
      placement: "right"
    }, visible.length ? /*#__PURE__*/React.createElement(VisibleIcon, {
      className: "icon",
      onClick: function onClick() {
        // eslint-disable-next-line no-unused-expressions
        handleChangeRegion({
          visible: false
        });
      }
    }) : /*#__PURE__*/React.createElement(VisibleOffIcon, {
      className: "icon",
      onClick: function onClick() {
        // eslint-disable-next-line no-unused-expressions
        handleChangeRegion({
          visible: true
        });
      }
    }))
  });
};

var MemoRowHeader = RowHeader;

var Row = function Row(_ref5) {
  var r = _ref5.region,
      highlighted = _ref5.highlighted,
      onSelectRegion = _ref5.onSelectRegion,
      onDeleteRegion = _ref5.onDeleteRegion,
      onChangeRegion = _ref5.onChangeRegion,
      visible = _ref5.visible,
      locked = _ref5.locked,
      color = _ref5.color,
      cls = _ref5.cls,
      index = _ref5.index,
      delete_annotation = _ref5.delete_annotation,
      setdelete_annotation = _ref5.setdelete_annotation,
      onClose = _ref5.onClose;
  return /*#__PURE__*/React.createElement(RowLayout, {
    header: false,
    highlighted: highlighted // onClick={() => onSelectRegion(r)}
    ,
    order: "#".concat(index + 1),
    classification: /*#__PURE__*/React.createElement(Chip, {
      text: cls || "",
      color: color || "#ddd"
    }),
    area: "",
    trash: /*#__PURE__*/React.createElement(Tooltip, {
      title: "Delete",
      placement: "right"
    }, /*#__PURE__*/React.createElement(TrashIcon, {
      onClick: function onClick() {
        onDeleteRegion(r);

        var delet_arr = _toConsumableArray(delete_annotation);

        delet_arr.push(r);
        var filterArr = delet_arr && delet_arr.filter(function (arr, index, self) {
          return index === self.findIndex(function (t) {
            return t.id === arr.id && arr.id;
          });
        }).map(function (item) {
          return item;
        });
        setdelete_annotation(filterArr);
      },
      className: "icon2"
    })),
    lock: r.locked ? /*#__PURE__*/React.createElement(Tooltip, {
      title: "Unlock",
      placement: "right"
    }, /*#__PURE__*/React.createElement(LockIcon, {
      onClick: function onClick() {
        onChangeRegion(_objectSpread({}, r, {
          locked: false,
          editingLabels: false
        }));
        onClose(r);
      },
      className: "icon2"
    })) : /*#__PURE__*/React.createElement(Tooltip, {
      title: "Lock",
      placement: "right"
    }, /*#__PURE__*/React.createElement(UnlockIcon, {
      onClick: function onClick() {
        return onChangeRegion(_objectSpread({}, r, {
          locked: true,
          editingLabels: false
        }));
      },
      className: "icon2"
    })),
    visible: r.visible || r.visible === undefined ? /*#__PURE__*/React.createElement(Tooltip, {
      title: "Hide",
      placement: "right"
    }, /*#__PURE__*/React.createElement(VisibleIcon, {
      onClick: function onClick() {
        return onChangeRegion(_objectSpread({}, r, {
          visible: false,
          editingLabels: false
        }));
      },
      className: "icon2"
    })) : /*#__PURE__*/React.createElement(Tooltip, {
      title: "Show",
      placement: "right"
    }, /*#__PURE__*/React.createElement(VisibleOffIcon, {
      onClick: function onClick() {
        return onChangeRegion(_objectSpread({}, r, {
          visible: true,
          editingLabels: false
        }));
      },
      className: "icon2"
    }))
  });
};

var MemoRow = memo(Row, function (prevProps, nextProps) {
  return prevProps.highlighted === nextProps.highlighted && prevProps.visible === nextProps.visible && prevProps.locked === nextProps.locked && prevProps.id === nextProps.id && prevProps.index === nextProps.index && prevProps.cls === nextProps.cls && prevProps.color === nextProps.color && prevProps.editingLabels === nextProps.editingLabels;
});
var emptyArr = [];
export var RegionSelectorSidebarBox = function RegionSelectorSidebarBox(_ref6) {
  var _ref6$regions = _ref6.regions,
      regions = _ref6$regions === void 0 ? emptyArr : _ref6$regions,
      onDeleteRegion = _ref6.onDeleteRegion,
      onChangeRegion = _ref6.onChangeRegion,
      onSelectRegion = _ref6.onSelectRegion,
      delete_annotation = _ref6.delete_annotation,
      setdelete_annotation = _ref6.setdelete_annotation,
      onClose = _ref6.onClose;
  var classes = useStyles();
  return /*#__PURE__*/React.createElement(ThemeProvider, {
    theme: theme
  }, /*#__PURE__*/React.createElement(SidebarBoxContainer, {
    title: "Regions",
    subTitle: "",
    icon: /*#__PURE__*/React.createElement(RegionIcon, {
      style: {
        color: grey[700]
      }
    }),
    expandedByDefault: true
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.container
  }, /*#__PURE__*/React.createElement(MemoRowHeader, {
    regions: regions,
    onChangeRegion: onChangeRegion,
    onDeleteRegion: onDeleteRegion,
    delete_annotation: delete_annotation,
    setdelete_annotation: setdelete_annotation
  }), /*#__PURE__*/React.createElement(HeaderSep, null), regions.map(function (r, i) {
    return /*#__PURE__*/React.createElement(MemoRow, Object.assign({
      key: r.id
    }, r, {
      region: r,
      index: i,
      onSelectRegion: onSelectRegion,
      onDeleteRegion: onDeleteRegion,
      onChangeRegion: onChangeRegion,
      delete_annotation: delete_annotation,
      setdelete_annotation: setdelete_annotation,
      onClose: onClose
    }));
  }))));
};

var mapUsedRegionProperties = function mapUsedRegionProperties(r) {
  return [r.id, r.color, r.locked, r.visible, r.highlighted, r.editingLabels];
};

export default memo(RegionSelectorSidebarBox, function (prevProps, nextProps) {
  return isEqual((prevProps.regions || emptyArr).map(mapUsedRegionProperties), (nextProps.regions || emptyArr).map(mapUsedRegionProperties));
});